/* Generated by CIL v. 1.7.3 */
/* print_CIL_Input is true */

#line 18 "triangle.c"
void __globinit_triangle(void) ;
extern void __CrestInit(void)  __attribute__((__crest_skip__)) ;
extern void __CrestHandleReturn(int id , long long val )  __attribute__((__crest_skip__)) ;
extern void __CrestReturn(int id )  __attribute__((__crest_skip__)) ;
extern void __CrestCall(int id , unsigned int fid )  __attribute__((__crest_skip__)) ;
extern void __CrestBranch(int id , int bid , unsigned char b )  __attribute__((__crest_skip__)) ;
extern void __CrestApply2(int id , int op , long long val )  __attribute__((__crest_skip__)) ;
extern void __CrestApply1(int id , int op , long long val )  __attribute__((__crest_skip__)) ;
extern void __CrestClearStack(int id )  __attribute__((__crest_skip__)) ;
extern void __CrestStore(int id , unsigned long addr )  __attribute__((__crest_skip__)) ;
extern void __CrestLoad(int id , unsigned long addr , long long val )  __attribute__((__crest_skip__)) ;
#line 212 "/usr/lib/gcc/x86_64-linux-gnu/4.8/include/stddef.h"
typedef unsigned long size_t;
#line 131 "/usr/include/x86_64-linux-gnu/bits/types.h"
typedef long __off_t;
#line 132 "/usr/include/x86_64-linux-gnu/bits/types.h"
typedef long __off64_t;
#line 44 "/usr/include/stdio.h"
struct _IO_FILE;
#line 44
struct _IO_FILE;
#line 48 "/usr/include/stdio.h"
typedef struct _IO_FILE FILE;
#line 144 "/usr/include/libio.h"
struct _IO_FILE;
#line 154 "/usr/include/libio.h"
typedef void _IO_lock_t;
#line 160 "/usr/include/libio.h"
struct _IO_marker {
   struct _IO_marker *_next ;
   struct _IO_FILE *_sbuf ;
   int _pos ;
};
#line 245 "/usr/include/libio.h"
struct _IO_FILE {
   int _flags ;
   char *_IO_read_ptr ;
   char *_IO_read_end ;
   char *_IO_read_base ;
   char *_IO_write_base ;
   char *_IO_write_ptr ;
   char *_IO_write_end ;
   char *_IO_buf_base ;
   char *_IO_buf_end ;
   char *_IO_save_base ;
   char *_IO_backup_base ;
   char *_IO_save_end ;
   struct _IO_marker *_markers ;
   struct _IO_FILE *_chain ;
   int _fileno ;
   int _flags2 ;
   __off_t _old_offset ;
   unsigned short _cur_column ;
   signed char _vtable_offset ;
   char _shortbuf[1] ;
   _IO_lock_t *_lock ;
   __off64_t _offset ;
   void *__pad1 ;
   void *__pad2 ;
   void *__pad3 ;
   void *__pad4 ;
   size_t __pad5 ;
   int _mode ;
   char _unused2[(15UL * sizeof(int ) - 4UL * sizeof(void *)) - sizeof(size_t )] ;
};
#line 202 "../bin/../include/crest.h"
extern void __CrestInt(int *x )  __attribute__((__crest_skip__)) ;
#line 170 "/usr/include/stdio.h"
extern struct _IO_FILE *stderr ;
#line 356
extern int fprintf(FILE * __restrict  __stream , char const   * __restrict  __format 
                   , ...) ;
#line 18 "triangle.c"
int main(void) 
{ 
  int a ;
  int b ;
  int c ;
  int __retres4 ;

  {
  __globinit_triangle();
  __CrestCall(1, 1);
#line 20
  __CrestInt(& a);
#line 21
  __CrestInt(& b);
#line 22
  __CrestInt(& c);
  __CrestLoad(4, (unsigned long )(& a), (long long )a);
  __CrestLoad(3, (unsigned long )0, (long long )0);
  __CrestApply2(2, 15, (long long )(a <= 0));
#line 24
  if (a <= 0) {
    __CrestBranch(5, 3, 1);
#line 25
    fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"NOT A TRIANGLE\n");
    __CrestClearStack(7);
    __CrestLoad(8, (unsigned long )0, (long long )1);
    __CrestStore(9, (unsigned long )(& __retres4));
#line 26
    __retres4 = 1;
#line 26
    goto return_label;
  } else {
    __CrestBranch(6, 6, 0);
    {
    __CrestLoad(12, (unsigned long )(& b), (long long )b);
    __CrestLoad(11, (unsigned long )0, (long long )0);
    __CrestApply2(10, 15, (long long )(b <= 0));
#line 27
    if (b <= 0) {
      __CrestBranch(13, 7, 1);
#line 28
      fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"NOT A TRIANGLE\n");
      __CrestClearStack(15);
      __CrestLoad(16, (unsigned long )0, (long long )1);
      __CrestStore(17, (unsigned long )(& __retres4));
#line 29
      __retres4 = 1;
#line 29
      goto return_label;
    } else {
      __CrestBranch(14, 10, 0);
      {
      __CrestLoad(20, (unsigned long )(& c), (long long )c);
      __CrestLoad(19, (unsigned long )0, (long long )0);
      __CrestApply2(18, 15, (long long )(c <= 0));
#line 30
      if (c <= 0) {
        __CrestBranch(21, 11, 1);
#line 31
        fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"NOT A TRIANGLE\n");
        __CrestClearStack(23);
        __CrestLoad(24, (unsigned long )0, (long long )1);
        __CrestStore(25, (unsigned long )(& __retres4));
#line 32
        __retres4 = 1;
#line 32
        goto return_label;
      } else {
        __CrestBranch(22, 14, 0);
        {
        __CrestLoad(30, (unsigned long )(& a), (long long )a);
        __CrestLoad(29, (unsigned long )(& b), (long long )b);
        __CrestApply2(28, 0, (long long )(a + b));
        __CrestLoad(27, (unsigned long )(& c), (long long )c);
        __CrestApply2(26, 15, (long long )(a + b <= c));
#line 33
        if (a + b <= c) {
          __CrestBranch(31, 15, 1);
#line 34
          fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"NOT A TRIANGLE\n");
          __CrestClearStack(33);
          __CrestLoad(34, (unsigned long )0, (long long )1);
          __CrestStore(35, (unsigned long )(& __retres4));
#line 35
          __retres4 = 1;
#line 35
          goto return_label;
        } else {
          __CrestBranch(32, 18, 0);
          {
          __CrestLoad(40, (unsigned long )(& a), (long long )a);
          __CrestLoad(39, (unsigned long )(& c), (long long )c);
          __CrestApply2(38, 0, (long long )(a + c));
          __CrestLoad(37, (unsigned long )(& b), (long long )b);
          __CrestApply2(36, 15, (long long )(a + c <= b));
#line 36
          if (a + c <= b) {
            __CrestBranch(41, 19, 1);
#line 37
            fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"NOT A TRIANGLE\n");
            __CrestClearStack(43);
            __CrestLoad(44, (unsigned long )0, (long long )1);
            __CrestStore(45, (unsigned long )(& __retres4));
#line 38
            __retres4 = 1;
#line 38
            goto return_label;
          } else {
            __CrestBranch(42, 22, 0);
            {
            __CrestLoad(50, (unsigned long )(& b), (long long )b);
            __CrestLoad(49, (unsigned long )(& c), (long long )c);
            __CrestApply2(48, 0, (long long )(b + c));
            __CrestLoad(47, (unsigned long )(& a), (long long )a);
            __CrestApply2(46, 15, (long long )(b + c <= a));
#line 39
            if (b + c <= a) {
              __CrestBranch(51, 23, 1);
#line 40
              fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"NOT A TRIANGLE\n");
              __CrestClearStack(53);
              __CrestLoad(54, (unsigned long )0, (long long )1);
              __CrestStore(55, (unsigned long )(& __retres4));
#line 41
              __retres4 = 1;
#line 41
              goto return_label;
            } else {
              __CrestBranch(52, 26, 0);

            }
            }
          }
          }
        }
        }
      }
      }
    }
    }
  }
  __CrestLoad(58, (unsigned long )(& a), (long long )a);
  __CrestLoad(57, (unsigned long )(& b), (long long )b);
  __CrestApply2(56, 12, (long long )(a == b));
#line 44
  if (a == b) {
    __CrestBranch(59, 28, 1);
    {
    __CrestLoad(63, (unsigned long )(& b), (long long )b);
    __CrestLoad(62, (unsigned long )(& c), (long long )c);
    __CrestApply2(61, 12, (long long )(b == c));
#line 45
    if (b == c) {
      __CrestBranch(64, 29, 1);
#line 46
      fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"EQUILATERAL\n");
      __CrestClearStack(66);
      __CrestLoad(67, (unsigned long )0, (long long )0);
      __CrestStore(68, (unsigned long )(& __retres4));
#line 47
      __retres4 = 0;
#line 47
      goto return_label;
    } else {
      __CrestBranch(65, 32, 0);
#line 49
      fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"ISOSCELES\n");
      __CrestClearStack(69);
      __CrestLoad(70, (unsigned long )0, (long long )0);
      __CrestStore(71, (unsigned long )(& __retres4));
#line 50
      __retres4 = 0;
#line 50
      goto return_label;
    }
    }
  } else {
    __CrestBranch(60, 35, 0);
    {
    __CrestLoad(74, (unsigned long )(& a), (long long )a);
    __CrestLoad(73, (unsigned long )(& c), (long long )c);
    __CrestApply2(72, 12, (long long )(a == c));
#line 52
    if (a == c) {
      __CrestBranch(75, 36, 1);
#line 53
      fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"ISOSCELES\n");
      __CrestClearStack(77);
      __CrestLoad(78, (unsigned long )0, (long long )0);
      __CrestStore(79, (unsigned long )(& __retres4));
#line 54
      __retres4 = 0;
#line 54
      goto return_label;
    } else {
      __CrestBranch(76, 39, 0);
      {
      __CrestLoad(82, (unsigned long )(& b), (long long )b);
      __CrestLoad(81, (unsigned long )(& c), (long long )c);
      __CrestApply2(80, 12, (long long )(b == c));
#line 56
      if (b == c) {
        __CrestBranch(83, 40, 1);
#line 57
        fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"ISOSCELES\n");
        __CrestClearStack(85);
        __CrestLoad(86, (unsigned long )0, (long long )0);
        __CrestStore(87, (unsigned long )(& __retres4));
#line 58
        __retres4 = 0;
#line 58
        goto return_label;
      } else {
        __CrestBranch(84, 43, 0);
#line 60
        fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"SCALENE\n");
        __CrestClearStack(88);
        __CrestLoad(89, (unsigned long )0, (long long )0);
        __CrestStore(90, (unsigned long )(& __retres4));
#line 61
        __retres4 = 0;
#line 61
        goto return_label;
      }
      }
    }
    }
  }
  return_label: /* CIL Label */ 
  {
  __CrestLoad(91, (unsigned long )(& __retres4), (long long )__retres4);
  __CrestReturn(92);
#line 18
  return (__retres4);
  }
}
}
void __globinit_triangle(void) 
{ 


  {
  __CrestInit();
}
}
